jQuery.fn.mapify = function(lat, lng, options){
  options.center = new google.maps.LatLng(lat, lng);
  
  var map = new google.maps.Map(jQuery(this).get(0), options);
  
  return map;
}

jQuery.fn.menuify = function(){
  var menu = jQuery(this);
  var menu_items = jQuery(this).children("li");
  
  $(window).scroll(function(){
  });
  
  $.each($(".modal"), function(){
    var wrapper_styles = {
      position: "absolute",
      "z-index": 999,
      top: 30,
      left: 20,
      right: 20
    }
    
    if($(this).height() < $(window).height()){ wrapper_styles.bottom = 0; }
    
    $(this).css(wrapper_styles);
  });
  
  menu_items.bind("touchstart", function(){
    menu_items.removeClass("active");
    $(this).addClass("active");
    
    $(".modal").hide();
    
    $($(this).attr("data-targets")).show();
  });
  
  $(".modal").hide();
  
  $(".modal").prepend("<span class=\"close\">D</span>");
  
  $(".modal .close").live("click", function(){ 
    menu_items.removeClass("active");
    $(this).parents(".modal").hide();
    menu.show();
  });
}

var data_in_info_window = true;

$(document).ready(function(){
  setTimeout(function(){ window.scrollTo(0, 1); }, 100);
  
  $("#icons").menuify();

  $(".lingo").hide();

  var run_map = function(){    
    $("#" + localStorage.getItem("language")).show();
    
    if(navigator.geolocation){
      navigator.geolocation.getCurrentPosition(function(current_location){
        var map = $("#map").mapify(current_location.coords.latitude, current_location.coords.longitude, {
          zoom: 12,
          minZoom: 10,
          scrollwheel: false,
          keyboardShortcuts: false,
          mapTypeId: google.maps.MapTypeId.ROADMAP,
          scrollwheel: false,
          streetViewControl: false,
          mapTypeControl: false,
          panControl: false,
          keyboardShortcuts: false,
          disableDefaultUI: true
        });
        
        if(localStorage.getItem("language") === "Français"){
          $("label[for=route_from]").text("De");
          $("label[for=route_to]").text("A");
          
          $("#locate_me").text("Planifiez votre route");
        }else if(localStorage.getItem("language") === "Nederlands"){
          $("label[for=route_from]").text("Van");
          $("label[for=route_to]").text("Naar");
          
          $("#locate_me").text("Routeplanner");
        }

        $("#plan_route input").label_to_value();
        
        map.mapTypes.set("pale_map", new google.maps.StyledMapType(map_style, { name: "Pale Map" }));
        map.setMapTypeId("pale_map");
        
        var loaded_ids = [];
        var rectangles = [];
        
        var colors = {
          "1-10": "#2e5595",
          "11-20": "#537bb1",
          "21-30": "#76b443",
          "31-40": "#9aca6d",
          "41-50": "#cfde68",
          "51-70": "#fcec63",
          "71-100": "#f2e343",
          "101-150": "#e58735",
          "151-200": "#d8522d",
          "201-300": "#ac4228"
        }
        
        var terms = {
          "Nederlands": {
            "1-10": "Uitstekend",
            "11-20": "zeer goed",
            "21-30": "goed",
            "31-40": "vrij goed",
            "41-50": "gewoon",
            "51-70": "middelmatig",
            "71-100": "ondermaats",
            "101-150": "slecht",
            "151-200": "zeer slecht",
            "201-300": "verschrikkelijk"
          },
          "Français": {
            "1-10": "excellente",
            "11-20": "très bonne",
            "21-30": "bonne",
            "31-40": "assez bonne",
            "41-50": "moyenne",
            "51-70": "médiocre",
            "71-100": "très médiocre",
            "101-150": "mauvaise",
            "151-200": "très mauvaise",
            "201-300": "exécrable"
          }
        }
        
        google.maps.event.addListener(map, "idle", function(){
          var query = {
            current_location: map.getCenter().lat() + "," + map.getCenter().lng(),
            outer_location: map.getBounds().getNorthEast().lat() + "," + map.getBounds().getNorthEast().lng(),
            ids: loaded_ids.join(",")
          }
          
          $.getJSON("http://toyota.abstraktion.co.uk/?" + $.param(query), function(response){ 
            var rectangle;
            
            $.each(response, function(){
              var base = ((Math.floor(this.average/10.0)*1) * 10) + 1;
              var range = base + "-" + (base + 9);
              
              var color = colors[range];
              
              if($("#pollution #amount").text() == ""){
                $("#pollution #amount").text(this.average);
                $("#human #term").text(terms[localStorage.getItem("language")][range]);
              }
              
              var air_quality_label = "Qualité de l'air";
              
              if(localStorage.getItem("language") === "Nederlands"){ air_quality_label = "Luchtkwaliteit"; }
              
              if(data_in_info_window && $("#info_box").text() == ""){
                var info_box_markup = "<div id=\"info_box_inner\"><div id=\"info_box_pollution_amount\"><span>" + this.average + "</span>ug/m<sup>3</sup></div><div id=\"info_box_pollution_label\">" + air_quality_label + "</div><div id=\"info_box_pollution_human\" style=\"color: " + color + ";\">" + terms[localStorage.getItem("language")][range] + "</div></div>";
                
                $("#info_box").html(info_box_markup);
              }
              
              if(!color){ console.log(range); }
              
              var term = terms[range];
              
              if(!rectangles[this.id]){                
                rectangles[this.id] = new google.maps.Polygon({
                  map: map,
                  paths: [
                    new google.maps.LatLng(this.points.ne.lat, this.points.ne.lng),
                    new google.maps.LatLng(this.points.se.lat, this.points.se.lng),
                    new google.maps.LatLng(this.points.sw.lat, this.points.sw.lng),
                    new google.maps.LatLng(this.points.nw.lat, this.points.nw.lng),
                  ],
                  fillColor: color,
                  fillOpacity: 0.4,
                  strokeWeight: 0
                });
              }
              
              loaded_ids.push(this.id);
            });
          });
        });
        
        var directions = new google.maps.DirectionsService();
        
        var direction_display = new google.maps.DirectionsRenderer();
        direction_display.setMap(map);
        direction_display.suppressMarkers = true;
    
        var start_marker, end_marker;
        route_requested = false;
    
        var marker_markup = "";
        
        if(data_in_info_window === true){ marker_markup += "<div id=\"info_box\"></div>"; }
        
        marker_markup += "<span id=\"map_marker\">@</span>";
    
        var marker = new RichMarker({
        	position: map.getCenter(),
        	map: map,
        	flat: true,
        	title: 'Current location',
        	content: marker_markup
        });
        
        $("#test").bind("touchstart", function(){ 
          map.setCenter(new google.maps.LatLng(50.920486,3.120117)); 
          marker.setPosition(new google.maps.LatLng(50.920486,3.120117));
        });
        
        $("#route_request").submit(function(e){
          e.preventDefault();
          
          if(route_requested){
            start_marker.setMap(null);
            end_marker.setMap(null);
          }
          
          $(".modal").hide();
          $("#icons li").removeClass("active");
          
          var route_request = {
            destination: $("#route_to").val(),
            travelMode: google.maps.DirectionsTravelMode.DRIVING
          };
          
          if(
            $("#route_from").val() === "Current location" ||
            $("#route_from").val() === "Current Location" ||
            $("#route_from").val() === "current location" ||
            $("#route_from").val() === "current Location"
          ){
            route_request.origin = marker.getPosition();
          }else{
            route_request.origin = $("#route_from").val();
          }

          directions.route(route_request, function(result, status){
            direction_display.setDirections(result);
            
            start_marker = new RichMarker({
              position: result.routes[0].legs[0].start_location,
            	map: map,
            	flat: true,
            	title: 'Start point',
            	content: "<span id=\"map_start_marker\"><span>@</span></span>"
            });

            end_marker = new RichMarker({
              position: result.routes[0].legs[0].end_location,
            	map: map,
            	flat: true,
            	title: 'End point',
            	content: "<span id=\"map_end_marker\"><span>@</span></span>"
            });
            
            setTimeout(function(){
              map.setCenter(result.routes[0].legs[0].start_location)
            }, 100);
            
            route_requested = true;
          });
        });
      },
      function(){
        $("body").append("<div id=\"error\">We need to know your current location to show surrounding pollution. This data is not recorded or shared.</div>");
      });
    }else{
      $("body").append("<div id=\"error\">Unfortunately your browser does not support geolocation.</div>");
    }
  }
  
  if(navigator.onLine){
    if(localStorage.getItem("language") && localStorage.getItem("language") != ""){
      run_map();
    }else{
      $("#language").show();
      
      $("#language a").bind("touchstart", function(e){
        e.preventDefault();
        
        $("#language").hide();
        
        localStorage.setItem("language", $(this).text());
        
        run_map();
      });
    }
  }else{
    $("body").append("<div id=\"error\">You must be connected, either via wifi or 3g, for this app to work.</div>");
  }
  
  // Disable scrolling
  $("html, body").bind("touchmove ", function(e){ e.preventDefault(); });

  var cur_y = 0;
  var prev_y = 0;
  var offset = 0;
  var element_height = 0;
  var parent_height = 0;
  var direction = "down";

  $(".scrollable").bind("touchstart", function(e){
    var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
  
    parent_height = $(this).parents(".content").height();
    element_height = $(this).height();
  
    prev_y = touch.pageY;
  }).bind("touchmove", function(e){      
    var touch = e.originalEvent.touches[0] || e.originalEvent.changedTouches[0];
  
    cur_y = touch.pageY;
  
    if(prev_y > cur_y && parent_height - offset <= element_height){ 
      offset = offset - (prev_y - cur_y);
    
      direction = "down";
    }else if(prev_y < cur_y && offset < 0){
      offset = offset + (cur_y - prev_y);
    
      direction = "up";
    }
  
    $(this).css("-webkit-transform", "translate3d(0, " + offset + "px, 0)");
  
    prev_y = cur_y;
  }).bind("touchend", function(){
    if(direction == "up" && offset > 0){
      $(this).css("-webkit-transform", "translate3d(0, 0, 0)");
    }else if(direction == "down" && (parent_height - offset) >= element_height){
      $(this).css("-webkit-transform", "translate3d(0, " + 0 - (element_height - parent_height) + "px, 0)");
    }
  
    cur_y = 0;
    prev_y = 0;
  });
});